## linux 6.12.63

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0
VERSION = 6
PATCHLEVEL = 12
SUBLEVEL = 63
EXTRAVERSION =
NAME = Baby Opossum Posse

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

ifeq ($(filter output-sync,$(.FEATURES)),)
$(error GNU Make >= 4.0 is required. Your Make version is $(MAKE_VERSION))
endif

$(if $(filter __%, $(MAKECMDGOALS)), \
	$(error targets prefixed with '__' are only for internal use))

# That's our default target when none is given on the command line
PHONY := __all
__all:

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.a targets which finally
# turn into vmlinux), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

this-makefile := $(lastword $(MAKEFILE_LIST))
abs_srctree := $(realpath $(dir $(this-makefile)))
abs_objtree := $(CURDIR)

ifneq ($(sub_make_done),1)

# Do not use make's built-in rules and variables
# (this increases performance and avoids hard-to-debug behaviour)
MAKEFLAGS += -rR

# Avoid funny character set dependencies
unexport LC_ALL
LC_COLLATE=C
LC_NUMERIC=C
export LC_COLLATE LC_NUMERIC

# Avoid interference with shell env settings
unexport GREP_OPTIONS

# Beautify output
# ---------------------------------------------------------------------------
#
# Most of build commands in Kbuild start with "cmd_". You can optionally define
# "quiet_cmd_*". If defined, the short log is printed. Otherwise, no log from
# that command is printed by default.
#
# e.g.)
#    quiet_cmd_depmod = DEPMOD  $(MODLIB)
#          cmd_depmod = $(srctree)/scripts/depmod.sh $(DEPMOD) $(KERNELRELEASE)
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#    $(Q)$(MAKE) $(build)=scripts/basic
#
# If KBUILD_VERBOSE contains 1, the whole command is echoed.
# If KBUILD_VERBOSE contains 2, the reason for rebuilding is printed.
#
# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifeq ("$(origin V)", "command line")
  KBUILD_VERBOSE = $(V)
endif

quiet = quiet_
Q = @

ifneq ($(findstring 1, $(KBUILD_VERBOSE)),)
  quiet =
  Q =
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands
ifneq ($(findstring s,$(firstword -$(MAKEFLAGS))),)
quiet=silent_
override KBUILD_VERBOSE :=
endif

export quiet Q KBUILD_VERBOSE

# Call a source code checker (by default, "sparse") as part of the
# C compilation.
#
# Use 'make C=1' to enable checking of only re-compiled files.
# Use 'make C=2' to enable checking of *all* source files, regardless
# of whether they are re-compiled or not.
#
# See the file "Documentation/dev-tools/sparse.rst" for more details,
# including where to get the "sparse" utility.

ifeq ("$(origin C)", "command line")
  KBUILD_CHECKSRC = $(C)
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

export KBUILD_CHECKSRC

# Enable "clippy" (a linter) as part of the Rust compilation.
#
# Use 'make CLIPPY=1' to enable it.
ifeq ("$(origin CLIPPY)", "command line")
  KBUILD_CLIPPY := $(CLIPPY)
endif

export KBUILD_CLIPPY

# Use make M=dir or set the environment variable KBUILD_EXTMOD to specify the
# directory of external module to build. Setting M= takes precedence.
ifeq ("$(origin M)", "command line")
  KBUILD_EXTMOD := $(M)
endif

$(if $(word 2, $(KBUILD_EXTMOD)), \
	$(error building multiple external modules is not supported))

$(foreach x, % :, $(if $(findstring $x, $(KBUILD_EXTMOD)), \
	$(error module directory path cannot contain '$x')))

# Remove trailing slashes
ifneq ($(filter %/, $(KBUILD_EXTMOD)),)
KBUILD_EXTMOD := $(shell dirname $(KBUILD_EXTMOD).)
endif

export KBUILD_EXTMOD

# backward compatibility
KBUILD_EXTRA_WARN ?= $(KBUILD_ENABLE_EXTRA_GCC_CHECKS)

ifeq ("$(origin W)", "command line")
  KBUILD_EXTRA_WARN := $(W)
endif

export KBUILD_EXTRA_WARN

# Kbuild will save output files in the current working directory.
# This does not need to match to the root of the kernel source tree.
#
# For example, you can do this:
#
#  cd /dir/to/store/output/files; make -f /dir/to/kernel/source/Makefile
#
# If you want to save output files in a different location, there are
# two syntaxes to specify it.
#
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the output directory.
# export KBUILD_OUTPUT=dir/to/store/output/files/; make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.

# Do we want to change the working directory?
ifeq ("$(origin O)", "command line")
  KBUILD_OUTPUT := $(O)
endif

ifneq ($(KBUILD_OUTPUT),)
# $(realpath ...) gets empty if the path does not exist. Run 'mkdir -p' first.
$(shell mkdir -p "$(KBUILD_OUTPUT)")
# $(realpath ...) resolves symlinks
abs_objtree := $(realpath $(KBUILD_OUTPUT))
$(if $(abs_objtree),,$(error failed to create output directory "$(KBUILD_OUTPUT)"))
endif # ifneq ($(KBUILD_OUTPUT),)

ifneq ($(words $(subst :, ,$(abs_srctree))), 1)
$(error source directory cannot contain spaces or colons)
endif

export sub_make_done := 1

endif # sub_make_done

ifeq ($(abs_objtree),$(CURDIR))
# Suppress "Entering directory ..." if we are at the final work directory.
no-print-directory := --no-print-directory
else
# Recursion to show "Entering directory ..."
need-sub-make := 1
endif

ifeq ($(filter --no-print-directory, $(MAKEFLAGS)),)
# If --no-print-directory is unset, recurse once again to set it.
# You may end up recursing into __sub-make twice. This is needed due to the
# behavior change in GNU Make 4.4.1.
need-sub-make := 1
endif

ifeq ($(need-sub-make),1)

PHONY += $(MAKECMDGOALS) __sub-make

$(filter-out $(this-makefile), $(MAKECMDGOALS)) __all: __sub-make
	@:

# Invoke a second make in the output directory, passing relevant variables
__sub-make:
	$(Q)$(MAKE) $(no-print-directory) -C $(abs_objtree) \
	-f $(abs_srctree)/Makefile $(MAKECMDGOALS)

else # need-sub-make

# We process the rest of the Makefile if this is the final invocation of make

ifeq ($(abs_srctree),$(abs_objtree))
        # building in the source tree
        srctree := .
	building_out_of_srctree :=
else
        ifeq ($(abs_srctree)/,$(dir $(abs_objtree)))
                # building in a subdirectory of the source tree
                srctree := ..
        else
                srctree := $(abs_srctree)
        endif
	building_out_of_srctree := 1
endif

ifneq ($(KBUILD_ABS_SRCTREE),)
srctree := $(abs_srctree)
endif

objtree		:= .

VPATH		:=

ifeq ($(KBUILD_EXTMOD),)
ifdef building_out_of_srctree
VPATH		:= $(srctree)
endif
endif

export building_out_of_srctree srctree objtree VPATH

# To make sure we do not include .config for any of the *config targets
# catch them early, and hand them over to scripts/kconfig/Makefile
# It is allowed to specify more targets when calling make, including
# mixing *config targets and build targets.
# For example 'make oldconfig all'.
# Detect when mixed targets is specified, and make a second invocation
# of make so .config is not included in this case either (for *config).

version_h := include/generated/uapi/linux/version.h

clean-targets := %clean mrproper cleandocs
no-dot-config-targets := $(clean-targets) \
			 cscope gtags TAGS tags help% %docs check% coccicheck \
			 $(version_h) headers headers_% archheaders archscripts \
			 %asm-generic kernelversion %src-pkg dt_binding_check \
			 outputmakefile rustavailable rustfmt rustfmtcheck
no-sync-config-targets := $(no-dot-config-targets) %install modules_sign kernelrelease \
			  image_name
single-targets := %.a %.i %.ko %.lds %.ll %.lst %.mod %.o %.rsi %.s %.symtypes %/

config-build	:=
mixed-build	:=
need-config	:= 1
may-sync-config	:= 1
single-build	:=

ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
        need-config :=
    endif
endif

ifneq ($(filter $(no-sync-config-targets), $(MAKECMDGOALS)),)
    ifeq ($(filter-out $(no-sync-config-targets), $(MAKECMDGOALS)),)
        may-sync-config :=
    endif
endif

need-compiler := $(may-sync-config)

ifneq ($(KBUILD_EXTMOD),)
    may-sync-config :=
endif

ifeq ($(KBUILD_EXTMOD),)
    ifneq ($(filter %config,$(MAKECMDGOALS)),)
        config-build := 1
        ifneq ($(words $(MAKECMDGOALS)),1)
            mixed-build := 1
        endif
    endif
endif

# We cannot build single targets and the others at the same time
ifneq ($(filter $(single-targets), $(MAKECMDGOALS)),)
    single-build := 1
    ifneq ($(filter-out $(single-targets), $(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

# For "make -j clean all", "make -j mrproper defconfig all", etc.
ifneq ($(filter $(clean-targets),$(MAKECMDGOALS)),)
    ifneq ($(filter-out $(clean-targets),$(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

# install and modules_install need also be processed one by one
ifneq ($(filter install,$(MAKECMDGOALS)),)
    ifneq ($(filter modules_install,$(MAKECMDGOALS)),)
        mixed-build := 1
    endif
endif

ifdef mixed-build
# ===========================================================================
# We're called with mixed targets (*config and build targets).
# Handle them one by one.

PHONY += $(MAKECMDGOALS) __build_one_by_one

$(MAKECMDGOALS): __build_one_by_one
	@:

__build_one_by_one:
	$(Q)set -e; \
	for i in $(MAKECMDGOALS); do \
		$(MAKE) -f $(srctree)/Makefile $$i; \
	done

else # !mixed-build

include $(srctree)/scripts/Kbuild.include

# Read KERNELRELEASE from include/config/kernel.release (if it exists)
KERNELRELEASE = $(call read-file, include/config/kernel.release)
KERNELVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
export VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION

include $(srctree)/scripts/subarch.include

# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=arm64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=aarch64-linux-gnu-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile
ARCH		?= $(SUBARCH)

# Architecture as present in compile.h
UTS_MACHINE 	:= $(ARCH)
SRCARCH 	:= $(ARCH)

# Additional ARCH settings for x86
ifeq ($(ARCH),i386)
        SRCARCH := x86
endif
ifeq ($(ARCH),x86_64)
        SRCARCH := x86
endif

# Additional ARCH settings for sparc
ifeq ($(ARCH),sparc32)
       SRCARCH := sparc
endif
ifeq ($(ARCH),sparc64)
       SRCARCH := sparc
endif

# Additional ARCH settings for parisc
ifeq ($(ARCH),parisc64)
       SRCARCH := parisc
endif

export cross_compiling :=
ifneq ($(SRCARCH),$(SUBARCH))
cross_compiling := 1

=== debian/changelog ===
linux (6.12.63-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports

 -- Ben Hutchings <benh@debian.org>  Fri, 02 Jan 2026 17:55:03 +0100

linux (6.12.63-1) trixie; urgency=medium

  * New upstream stable update:
    https://www.kernel.org/pub/linux/kernel/v6.x/ChangeLog-6.12.58
    - NFSD: Fix crash in nfsd4_read_release()
    - net: usb: asix_devices: Check return value of usbnet_get_endpoints
    - fbcon: Set fb_display[i]->mode to NULL when the mode is released
    - fbdev: atyfb: Check if pll_ops->init_pll failed
    - ACPI: video: Fix use-after-free in acpi_video_switch_brightness()
    - ACPI: button: Call input_free_device() on failing input device
      registration
    - virtio-net: drop the multi-buffer XDP packet in zerocopy
    - fbdev: bitblit: bound-check glyph index in bit_putcs*
    - Bluetooth: rfcomm: fix modem control handling
    - wifi: brcmfmac: fix crash while sending Action Frames in standalone AP
      Mode
    - mptcp: drop bogus optimization in __mptcp_check_push()
    - mptcp: restore window probe
    - [arm64] ASoC: qdsp6: q6asm: do not sleep while atomic
    - [s390x] pci: Restore IRQ unconditionally for the zPCI device
    - smb: client: fix potential cfid UAF in smb2_query_info_compound
    - [amd64] x86/fpu: Ensure XFD state on signal delivery
    - wifi: ath10k: Fix memory leak on unsupported WMI command
    - wifi: ath11k: Add missing platform IDs for quirk table
    - wifi: ath12k: free skb during idr cleanup callback
    - wifi: ath11k: add support for MU EDCA
    - wifi: ath11k: avoid bit operation on key flags
    - [arm64] drm/msm/a6xx: Fix GMU firmware parser
    - ALSA: usb-audio: fix control pipe direction
    - wifi: mac80211: don't mark keys for inactive links as uploaded
    - wifi: mac80211: fix key tailroom accounting leak
    - bpf: Sync pending IRQ work before freeing ring buffer
    - scsi: ufs: core: Initialize value of an attribute returned by uic cmd
    - bpf: Find eligible subprogs for private stack support
    - bpf, x86: Avoid repeated usage of bpf_prog->aux->stack_depth
    - bpf: Do not audit capability check in do_jit()
    - [amd64] ASoC: Intel: avs: Unprepare a stream when XRUN occurs
    - [amd64] ASoC: Intel: avs: Disable periods-elapsed work when closing PCM
    - [arm64,armhf] ASoC: fsl_sai: fix bit order for DSD format
    - libbpf: Fix powerpc's stack register definition in bpf_tracing.h
    - usbnet: Prevents free active kevent
    - Bluetooth: hci_sync: fix race in hci_cmd_sync_dequeue_once
    - Bluetooth: ISO: Update hci_conn_hash_lookup_big for Broadcast slave
    - Bluetooth: ISO: Fix BIS connection dst_type handling
    - Bluetooth: btmtksdio: Add pmctrl handling for BT closed state during reset
    - Bluetooth: HCI: Fix tracking of advertisement set/instance 0x00
    - Bluetooth: ISO: Fix another instance of dst_type handling
    - Bluetooth: hci_core: Fix tracking of periodic advertisement
    - [arm64,armhf] drm/etnaviv: fix flush sequence logic
    - [arm64] net: hns3: return error code when function fails
    - sfc: fix potential memory leak in efx_mae_process_mport()
    - dpll: spec: add missing module-name and clock-id to pin-get reply
    - [arm64,armhf] ASoC: fsl_sai: Fix sync error in consumer mode
    - drm/radeon: Do not kfree() devres managed rdev
    - drm/radeon: Remove calls to drm_put_dev()
    - drm/amd/pm: fix smu table id bound check issue in smu_cmn_update_table()
    - drm/amd/pm/powerplay/smumgr: Fix PCIeBootLinkLevel value on Fiji
    - drm/amd/pm/powerplay/smumgr: Fix PCIeBootLinkLevel value on Iceland
    - ACPI: fan: Use ACPI handle when retrieving _FST
    - block: fix op_is_zone_mgmt() to handle REQ_OP_ZONE_RESET_ALL
    - block: make REQ_OP_ZONE_OPEN a write operation
    - regmap: slimbus: fix bus_context pointer in regmap init calls
    - [s390x] mm: Fix memory leak in add_marker() when kvrealloc() fails
    - drm/xe: Do not wake device during a GT reset
    - drm/sysfb: Do not dereference NULL pointer in plane reset
    - drm/sched: avoid killing parent entity on child SIGKILL
    - drm/nouveau: Fix race in nouveau_sched_fini()
    - [arm64] drm/mediatek: Fix device use-after-free on unbind
    - drm/amd: Check that VPE has reached DPM0 in idle handler
    - drm/amd/display: Fix incorrect return of vblank enable on unconfigured
      crtc (Closes: #1000966)
    - ACPI: fan: Add fan speed reporting for fans with only _FST
    - ACPI: fan: Use platform device for devres-related actions
    - sched_ext: Mark scx_bpf_dsq_move_set_[slice|vtime]() with KF_RCU
    - cpuidle: governors: menu: Rearrange main loop in menu_select()
    - cpuidle: governors: menu: Select polling state in some more cases
    - [amd64] mfd: kempld: Switch back to earlier ->init() behavior
    - [amd64] x86/CPU/AMD: Add RDSEED fix for Zen5
    - usb: gadget: f_fs: Fix epfile null pointer access after ep enable.
    - drm/sched: Optimise drm_sched_entity_push_job
    - drm/sched: Re-group and rename the entity run-queue lock
    - drm/sched: Fix race in drm_sched_entity_select_rq()
    - [s390x] pci: Avoid deadlock between PCI error recovery and mlx5 crdump
    - [s390x] Disable ARCH_WANT_OPTIMIZE_HUGETLB_VMEMMAP
    - [armhf] soc: aspeed: socinfo: Add AST27xx silicon IDs
    - [arm64] firmware: qcom: scm: preserve assign_mem() error return value
    - [arm64] soc: qcom: smem: Fix endian-unaware access of num_entries
    - [arm64] soc: ti: pruss: don't use %pK through printk
    - bpf: Don't use %pK through printk
    - pinctrl: single: fix bias pull up/down handling in pin_config_set
    - [arm64] mmc: host: renesas_sdhi: Fix the actual clock
    - memstick: Add timeout to prevent indefinite waiting
    - [arm64,armhf] cpufreq: ti: Add support for AM62D2
    - bpf: Use tnums for JEQ/JNE is_branch_taken logic
    - firewire: ohci: move self_id_complete tracepoint after validating register
    - [riscv64] irqchip/sifive-plic: Respect mask state when setting affinity


=== debian/control ===
Source: linux
Section: kernel
Priority: optional
Maintainer: Debian Kernel Team <debian-kernel@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>, maximilian attems <maks@debian.org>, Ben Hutchings <benh@debian.org>, Salvatore Bonaccorso <carnil@debian.org>
Standards-Version: 4.2.0
Build-Depends: debhelper-compat (= 13), python3:native, python3-dacite:native, python3-jinja2:native, quilt, dh-python <!pkg.linux.notools>
Build-Depends-Arch: bc <!pkg.linux.nokernel>, libssl-dev:native <!pkg.linux.nokernel>, libssl-dev <!pkg.linux.notools>, openssl <!pkg.linux.nokernel>, libelf-dev:native <!pkg.linux.nokernel>, libelf-dev [linux-any] <!pkg.linux.notools>, lz4 [amd64 arm64] <!pkg.linux.nokernel>, pahole <!pkg.linux.nokernel> | dwarves:native (>= 1.16~) <!pkg.linux.nokernel>, cpio <!pkg.linux.nokernel>, xz-utils <!pkg.linux.nokernel>, zstd <!pkg.linux.nokernel>, bison <!pkg.linux.nokernel>, bison <!pkg.linux.notools>, flex <!pkg.linux.nokernel>, flex <!pkg.linux.notools>, gcc-12 [alpha amd64 arm64 armel armhf hppa loong64 m68k mips mips64 mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64] <!cross !pkg.linux.nokernel>, gcc-12-alpha-linux-gnu [alpha] <cross !pkg.linux.nokernel>, gcc-12-x86-64-linux-gnu [amd64] <cross !pkg.linux.nokernel>, gcc-12-aarch64-linux-gnu [arm64] <cross !pkg.linux.nokernel>, gcc-arm-linux-gnueabihf [arm64] <!pkg.linux.nokernel>, gcc-12-arm-linux-gnueabi [armel] <cross !pkg.linux.nokernel>, gcc-12-arm-linux-gnueabihf [armhf] <cross !pkg.linux.nokernel>, gcc-12-hppa-linux-gnu [hppa] <cross !pkg.linux.nokernel>, gcc-12-hppa64-linux-gnu [hppa] <!pkg.linux.nokernel>, gcc-12-loongarch64-linux-gnu [loong64] <cross !pkg.linux.nokernel>, gcc-12-m68k-linux-gnu [m68k] <cross !pkg.linux.nokernel>, gcc-12-mips-linux-gnu [mips] <cross !pkg.linux.nokernel>, gcc-12-mips64-linux-gnuabi64 [mips64] <cross !pkg.linux.nokernel>, gcc-12-mips64el-linux-gnuabi64 [mips64el] <cross !pkg.linux.nokernel>, gcc-12-mipsisa64r6el-linux-gnuabi64 [mips64r6el] <cross !pkg.linux.nokernel>, gcc-12-mipsel-linux-gnu [mipsel] <cross !pkg.linux.nokernel>, gcc-12-powerpc-linux-gnu [powerpc] <cross !pkg.linux.nokernel>, gcc-12-powerpc64-linux-gnu [ppc64] <cross !pkg.linux.nokernel>, gcc-12-powerpc64le-linux-gnu [ppc64el] <cross !pkg.linux.nokernel>, gcc-12-riscv64-linux-gnu [riscv64] <cross !pkg.linux.nokernel>, gcc-12-s390x-linux-gnu [s390x] <cross !pkg.linux.nokernel>, gcc-12-sh4-linux-gnu [sh4] <cross !pkg.linux.nokernel>, gcc-12-sparc64-linux-gnu [sparc64] <cross !pkg.linux.nokernel>, python3-docutils [amd64 arm64 armhf i386 linux-any x32] <!nodoc !pkg.linux.notools> <!pkg.linux.mintools !pkg.linux.notools>, binutils-dev [hppa] <!pkg.linux.mintools !pkg.linux.notools>, zlib1g-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libcap-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libpci-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libnl-3-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libnl-genl-3-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, asciidoctor [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nodoc !nopython !pkg.linux.notools>, gcc-multilib [amd64 mips64 mips64el mips64r6 mips64r6el ppc64 s390x sparc64] <!cross>, libaudit-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libbabeltrace-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libdebuginfod-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libdw-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libnewt-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libnuma-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libopencsd-dev (>= 1.1.1) [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libperl-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libpython3-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libtraceevent-dev (>= 1:1.5) [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64 x32] <!pkg.linux.mintools !pkg.linux.notools>, libunwind-dev [amd64 arm64 armel armhf hppa i386 mips mips64 mips64el mipsel powerpc ppc64 ppc64el sh4] <!nopython !pkg.linux.mintools !pkg.linux.notools>, libzstd-dev [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, python3-dev:any [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, python3-setuptools [alpha amd64 arm64 armel armhf hppa i386 loong64 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 ppc64el riscv64 s390 s390x sh4 sparc sparc64] <!nopython !pkg.linux.mintools !pkg.linux.notools>, autoconf [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, automake [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libtool [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libglib2.0-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libudev-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libwrap0-dev [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, rsync [linux-any] <!pkg.linux.mintools !pkg.linux.notools>, libtracefs-dev (>= 1.3) [amd64 arm64 armhf i386 x32] <!pkg.linux.mintools !pkg.linux.notools>, kernel-wedge (>= 2.105~) [alpha amd64 arm64 armel armhf hppa loong64 m68k mips mips64 mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64] <!pkg.linux.nokernel>, kmod [alpha amd64 arm64 armel armhf hppa loong64 m68k mips mips64 mips64el mips64r6el mipsel powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64] <!pkg.linux.nokernel>
Build-Depends-Indep: cpio <!nodoc !pkg.linux.quick>, graphviz <!nodoc !pkg.linux.quick>, python3-sphinx <!nodoc !pkg.linux.quick>, python3-sphinx-rtd-theme <!nodoc !pkg.linux.quick>, texlive-latex-base <!nodoc !pkg.linux.quick>, texlive-latex-extra <!nodoc !pkg.linux.quick>, dvipng <!nodoc !pkg.linux.quick>, python3-yaml <!nodoc !pkg.linux.quick>, sphinx-common <!nodoc !pkg.linux.quick>, patchutils <!pkg.linux.nosource !pkg.linux.quick>, xz-utils <!pkg.linux.nosource !pkg.linux.quick>, rsync
Rules-Requires-Root: no
Homepage: https://www.kernel.org/
Vcs-Browser: https://salsa.debian.org/kernel-team/linux
Vcs-Git: https://salsa.debian.org/kernel-team/linux.git

Package: bpftool
Architecture: linux-any
Section: devel
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Inspection and simple manipulation of BPF programs and maps
 The bpftool command allows for inspection and simple modification of
 Berkeley Packet Filter (BPF) objects on the system.

Package: hyperv-daemons
Architecture: amd64 arm64 i386 x32
Section: admin
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Support daemons for Linux running on Hyper-V
 Suite of daemons for Linux guests running on Hyper-V, consisting of
 hv_kvp_daemon and hv_vss_daemon.
 .
 hv_kvp_daemon provides the key-value pair (KVP) service, allowing the host
 to get and set the IP networking configuration of the guest.  (This
 requires helper scripts which are not currently included.)
 .
 hv_vss_daemon provides the volume shadow copy service (VSS), allowing the
 host to freeze the guest filesystems while taking a snapshot.

Package: intel-sdsi
Architecture: amd64
Section: admin
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel On Demand (SDSi) provisioning tool
 intel_sdsi is a tool for key certificate and activation payload
 provisioning on Intel Xeon family processors with support for Intel On
 Demand (formerly known as Software Defined Silicon or SDSi).
 .
 intel_sdsi allows the configuration of additional CPU features through a
 license activation process.

Package: libcpupower-dev
Architecture: linux-any
Section: libdevel
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Provides: libcpufreq-dev
Depends: ${misc:Depends}, libcpupower1 (= ${binary:Version})
Replaces: libcpufreq-dev
Conflicts: libcpufreq-dev
Description: CPU frequency and voltage scaling tools for Linux (development files)
 libcpupower is a library for inspecting and controlling cpufreq and
 cpuidle tunables.
 .
 This package is needed to compile programs against libcpupower.

Package: libcpupower1
Architecture: linux-any
Section: libs
Build-Profiles: <!pkg.linux.mintools !pkg.linux.notools>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CPU frequency and voltage scaling tools for Linux (libraries)
 libcpupower is a library for inspecting and controlling cpufreq and
 cpuidle tunables.
 .
 This package contains the shared library.

Package: linux-bpf-dev
Architecture: alpha amd64 arm64 armhf hppa loong64 m68k ppc64 ppc64el riscv64 s390x sparc64
Section: devel
Build-Profiles: <!pkg.linux.nokernel !pkg.linux.quick>
Depends: ${misc:Depends}
Multi-Arch: same
Description: Headers for BPF development
 The vmlinux.h header is provided to allow userspace to build BPF CO-RE
 programs targeting the packaged kernel.

Package: linux-config-6.12
Architecture: linux-any
Build-Profiles: <!pkg.linux.nosource>
Depends: ${misc:Depends}
Recommends: linux-source-6.12
Multi-Arch: same
Description: Debian kernel configurations for Linux 6.12
 This package contains the configuration files used to build the official
 Debian kernel files, but without references to Debian's signing
 certificates.

=== debian/tests/control ===
Test-Command: py.test debian/lib/python
Restrictions: superficial
Depends: python3-pytest, python3-jinja2

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-alpha-generic
Architecture: alpha
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-alpha-generic
Depends: linux-headers-6.12.63+deb12-alpha-generic, linux-image-6.12.63+deb12-alpha-generic

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-alpha-smp
Architecture: alpha
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-alpha-smp
Depends: linux-headers-6.12.63+deb12-alpha-smp, linux-image-6.12.63+deb12-alpha-smp

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-amd64
Architecture: amd64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-amd64
Depends: linux-headers-6.12.63+deb12-amd64, linux-image-6.12.63+deb12-amd64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-cloud-amd64
Architecture: amd64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-cloud-amd64
Depends: linux-headers-6.12.63+deb12-cloud-amd64, linux-image-6.12.63+deb12-cloud-amd64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-rt-amd64
Architecture: amd64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rt-amd64
Depends: linux-headers-6.12.63+deb12-rt-amd64, linux-image-6.12.63+deb12-rt-amd64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-arm64
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-arm64
Depends: linux-headers-6.12.63+deb12-arm64, linux-image-6.12.63+deb12-arm64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-cloud-arm64
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-cloud-arm64
Depends: linux-headers-6.12.63+deb12-cloud-arm64, linux-image-6.12.63+deb12-cloud-arm64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-arm64-16k
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-arm64-16k
Depends: linux-headers-6.12.63+deb12-arm64-16k, linux-image-6.12.63+deb12-arm64-16k-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-rt-arm64
Architecture: arm64
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rt-arm64
Depends: linux-headers-6.12.63+deb12-rt-arm64, linux-image-6.12.63+deb12-rt-arm64-unsigned

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-rpi
Architecture: armel
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-rpi
Depends: linux-headers-6.12.63+deb12-rpi, linux-image-6.12.63+deb12-rpi

Test-Command: debian/tests/headers-kbuild 6.12.63+deb12-armmp
Architecture: armhf
Restrictions: skip-not-installable, superficial
Features: test-name=headers-kbuild-armmp
